import ddf.minim.*;

// based on Blobby by Golan Levin, 1998-2006

boolean bForPrintOutput = false;

float fmouseX, fmouseY;


Vector blobVector;
int[] blobAssociatedWithPath;
Point tempPoint;
Point squareReturnPoint;
Point squareContainingPixelPoint;
Point rootPoint;
Point edgeSquarePoint;

LissaPath lissaPathArray[];
int maxLissaPaths;
int nLissaPaths;
int currentLissaPath;

int R; 
float maxVal;
int threshHold;
float cachedField[][];
int squareSize;
int xSquares, ySquares;
int nSquares;

final int MAX_BOUNDARY_LENGTH = 1000;
final int CONVERGE_TESTS = 4;
final int  CAPACITY_INCREMENT = 500;
final int  LINEAR_RETURN = 0;
final int  SPLINE_RETURN = 1;
color blobColor   = color (255,225,235);//235,240,255);
color nubbColor   = color (200,0,0);
color shadowColor = color (100,100,150);
color bgColor     = color (160,170,255);

final int N_RESAMPLES = 256;
Vec2f resampledPolygon[];
Polygon returnBlobs[];
int CURB = 0;

boolean bDoSwivel = true;

float blurMx;
float blurMy;
PImage bg;

AudioSnippet players[];
int currPlayer;
int nPlayers;

float starx, stary;

//------------------------------------------------------------------------------------------
void setup(){
  size(640,360,P3D);
  randomSeed(4);
  initBlobby();
  initLPs();

  bg = loadImage("bg.png");

  Minim.start(this);
  nPlayers = 3;
  currPlayer = 0;
  players = new AudioSnippet[nPlayers];
  for (int i=0; i<nPlayers; i++){
    players[i] = Minim.loadSnippet("quish" + i + ".aif"); 
  }
}


void stop(){
  // an AudioPlayer you got from Minim.loadFile()
  for (int i=0; i<nPlayers; i++){
    players[i].close();
  }
  super.stop();
}


//============================================================
void initBlobby() {


  maxLissaPaths = 21;
  nLissaPaths   = 0;
  currentLissaPath = -1;
  lissaPathArray = new LissaPath[maxLissaPaths];

  blurMx = width/2;
  blurMy = height/2;
  starx = width * (1 - 0.618);
  stary = 20;

  squareSize = 10;
  xSquares = width/squareSize;
  ySquares = height/squareSize;
  nSquares = xSquares * ySquares;

  // cache field
  R = 64;
  maxVal = 1024.0;
  threshHold = 850;
  createCachedField(R);

  blobVector = new Vector(maxLissaPaths);
  blobAssociatedWithPath = new int[maxLissaPaths];
  tempPoint                  = new Point();
  squareReturnPoint          = new Point();
  squareContainingPixelPoint = new Point();
  edgeSquarePoint            = new Point();
  rootPoint                  = new Point();
  
  CURB = 0;
  returnBlobs = new Polygon[maxLissaPaths];
  for (int i=0; i<maxLissaPaths; i++){
    returnBlobs[i] = new Polygon();
  }

  resampledPolygon = new Vec2f[N_RESAMPLES];
  for (int i=0; i<N_RESAMPLES; i++){
    resampledPolygon[i] = new Vec2f();
  }




}

void initLPs(){
  float x,y;
  for (int i=0; i<maxLissaPaths; i++){
    if (i<9){
      x = width *(0.18 + 0.005*random(-1,1));
      y = height*(0.55 + 0.10*(random(-1,1) + random(-1,1)));
      if (i%9 == 1){
        x = width *(0.185);
        y = height*(0.375);
      }
      createNewLP(x,y);
    } 
    else if (i<18){
      x = width *(0.82 + 0.005*random(-1,1));
      y = height*(0.55 + 0.10*(random(-1,1) + random(-1,1)));
      if (i%9 == 1){
        x = width *(0.817);
        y = height*(0.425);
      }
      createNewLP(x,y);
    } 
    else if (i<21){
      x = width *(0.50 + 0.005*random(-1,1));
      y = height*(0.35 + 0.02*(random(-1,1) + random(-1,1)));
      createNewLP(x,y);
      lissaPathArray[i].who = 2;
      lissaPathArray[i].DAMPING = 0.9325;
    } 
    /*
    else if (i==21){
      x = blurMx;
      y = blurMy;
      createNewLP(x,y);
      lissaPathArray[i].who = 3;
      lissaPathArray[i].DAMPING = 0.85;
    }
    */
  }
}


int babyMode = 0;
void shiftBaby(){
  babyMode = (babyMode+1)%2;
  for (int i=18; i<21; i++){
    lissaPathArray[i].vel.y += 28;
  }
}

//---------------------------------------------
void draw(){
  background(bg);//160,170,255); 
  idleBlobby();

  pushMatrix();
  doSwivelCamera();
  drawShadowWorld();
  drawPinkWorld();
  drawLissaSpots();
  popMatrix();

  drawStar(starx, stary); 

}


//------------------------------------------------
void drawPinkWorld(){
  pushMatrix();
  translate(0,0,-0.2);
  fill(100,0,0, 128);
  noStroke();
  renderBlobby(3);
  translate(0,0, 0.1);
  fill(blobColor);
  renderBlobby(2);
  popMatrix();
  fill(blobColor); 
  renderBlobby(1);
}


//------------------------------------------------
void drawLissaSpots(){
  translate(0,0, 0.1);
  for (int i=0; i<nLissaPaths; i++){
    lissaPathArray[i].render();
  } 
}

//------------------------------------------------
void drawShadowWorld(){
  float x = 70.0;
  float y = 0.958 * height;
  pushMatrix();
  translate(0, height*0.666, 0);
  translate(0,0,0-y);
  rotateX(DEG_TO_RAD*x);
  translate(0,0, -10);

  noStroke();
  fill(shadowColor);
  renderBlobby(0);
  renderBlobby(2);
  drawCursorShadow(); 

  popMatrix();
}

//------------------------------------------------
void doSwivelCamera(){
  if (bDoSwivel){
    if ((mouseX != 0) && (mouseY != 0)){
      float A = 0.95;
      float B = 1.0-A;
      blurMx = (A*blurMx + B*mouseX);
      blurMy = (A*blurMy + B*mouseY);
    }
    float swivelX = 0.4*(blurMx - (width/2.0))/(width/2.0);
    float swivelY = 0.2*(blurMy - (height/2.0))/(height/2.0);
    swivelX += 0.15*sin(millis()/3000.0);
    swivelY += 0.10*sin(millis()/4000.0);
    translate(width/2,0,0); 
    rotateY(swivelX);
    translate(-width/2,0,0); 
    translate(0,height/2,0); 
    rotateX(swivelY);
    translate(0,-height/2,0); 
  } 
}


//------------------------------------------------
void drawCursorShadow(){
  pushMatrix();
  translate(mouseX, mouseY);
  scale(1.5,1.5,1);
  beginShape();
  vertex(0, 0);
  vertex(7, 7);
  vertex(4, 7);
  vertex(6, 13);
  vertex(4, 13);
  vertex(2, 8);
  vertex(0, 10);
  endShape(CLOSE);
  popMatrix(); 
}
//------------------------------------------------
void drawStar(float x, float y){
  float alp = 100 + 155*noise(millis()/250.0);
  beginShape(LINES);
  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x, y - 12);

  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x, y + 12);

  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x-12, y);

  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x+12, y);

  endShape(); 
}








//============================================================
void idleBlobby() {


  for (int i=0; i<nLissaPaths; i++){
    lissaPathArray[i].update();
  }
  for (int i=0; i<nLissaPaths; i++){
    lissaPathArray[i].integrate();
  }

}



//============================================================
void renderBlobby(int whichPass){

  if (nLissaPaths > 0){

    Polygon blob; 
    int nBlobs; 
    int b = 0; 
    int p = 0;
    FPoint sourcePoint;
    Point sourceSquare;
    boolean alreadyConsidered;

    float er = 8;
    switch(whichPass){
    case 2: 
      er = 8; 
      break;
    case 3: 
      er = 10; 
      break;
    }

    ////////////////////////////
    switch(whichPass){


    case 2:
    case 3:
      nBlobs = blobVector.size();
      for (b=0; b<nBlobs; b++){
        blob = (Polygon)(blobVector.elementAt(b));
        int np = resamplePolygon (blob, resampledPolygon, N_RESAMPLES);
        for (int i=0; i<np; i++){
          float px = resampledPolygon[i].x;
          float py = resampledPolygon[i].y;
          ellipse(px, py, er,er); 
        }

      }
      break;

    case 1:
      nBlobs = blobVector.size();
      for (b=0; b<nBlobs; b++){
        blob = (Polygon)(blobVector.elementAt(b));
        int np2 = blob.npoints;
        int xp[] = blob.xpoints;
        int yp[] = blob.ypoints;
        beginShape();
        for (int i=0; i<np2; i++){
          vertex(xp[i], yp[i]); 
        }
        endShape(CLOSE);
      }
      break;



    case 0:     
      CURB = 0; 
      blobVector.removeAllElements();
      for (p=0; p<nLissaPaths; p++){  

        // for each source's current position,
        sourcePoint = lissaPathArray[p].getCurrentPoint();	

        tempPoint.x = (int)round(sourcePoint.x);
        tempPoint.y = (int)round(sourcePoint.y);
        alreadyConsidered = false;

        for (b=0; b<blobVector.size(); b++){ 
          // test each of the sources to see if they need their own blob
          blob = (Polygon)(blobVector.elementAt(b)); 

          if (blob.contains(tempPoint)) { 
            blobAssociatedWithPath[p] = b;
            alreadyConsidered = true; 
          }
        }
        if (alreadyConsidered == false){
          // make, then draw the blob
          sourceSquare = getSquareContainingPixel(tempPoint.x, tempPoint.y); // get the square on that pixel
          blob = computeBoundary(sourceSquare);
          blobAssociatedWithPath[p] = blobVector.size();
          blobVector.addElement(blob);
          CURB++;

          int np2 = blob.npoints;
          int xp[] = blob.xpoints;
          int yp[] = blob.ypoints;
          beginShape();
          for (int i=0; i<np2; i++){
            vertex(xp[i], yp[i]); 
          }
          endShape(CLOSE);

        }
      }
      break;

    }


  }
}







void createNewLP(float x, float y){
  currentLissaPath = (int) ((currentLissaPath+1)%maxLissaPaths);
  nLissaPaths = (int) (Math.min (maxLissaPaths, nLissaPaths+1));
  int who = (currentLissaPath >= maxLissaPaths/2) ? 1 : 0;
  lissaPathArray[currentLissaPath] = new LissaPath(x, y, who, currentLissaPath);
}


//============================================================
void mousePressed() {
  
  if ((abs(mouseX - starx) < 4) && (abs(mouseY - stary) < 4)){
    currentLissaPath = -1;
    nLissaPaths = 0;
    initLPs();
  }

  players[currPlayer].pause();
  int prev = currPlayer;
  int r = (int)random(nPlayers*0.99);
  while (r == prev){
    r = (int)random(nPlayers*0.99);
  }
  currPlayer = r;
  players[currPlayer].rewind();
  players[currPlayer].play();
  
  shiftBaby();
}

//============================================================
void mouseDragged () {
}

//============================================================
void mouseMoved () {
}

//============================================================
void mouseReleased () { 

}

//============================================================
void keyPressed () {
  switch ((char)key){
  default:
  case ' ':
    currentLissaPath = -1;
    nLissaPaths = 0;
    initLPs();
    break;

    /*
  case '=': 
     case '+':
     threshHold = Math.max(50, threshHold - 25); 
     break;
     case '-': 
     case '_':
     threshHold = Math.min((int)maxVal, threshHold + 25); 
     break;
     */

  }
}







